cmdlib: Extract storage related functionality
[ganeti-github.git] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 cmdlibdir = $(pkgpythondir)/cmdlib
44 hypervisordir = $(pkgpythondir)/hypervisor
45 httpdir = $(pkgpythondir)/http
46 masterddir = $(pkgpythondir)/masterd
47 confddir = $(pkgpythondir)/confd
48 rapidir = $(pkgpythondir)/rapi
49 serverdir = $(pkgpythondir)/server
50 watcherdir = $(pkgpythondir)/watcher
51 impexpddir = $(pkgpythondir)/impexpd
52 utilsdir = $(pkgpythondir)/utils
53 toolsdir = $(pkglibdir)/tools
54 iallocatorsdir = $(pkglibdir)/iallocators
55 pytoolsdir = $(pkgpythondir)/tools
56 docdir = $(datadir)/doc/$(PACKAGE)
57 myexeclibdir = $(pkglibdir)
58
59 # Delete output file if an error occurred while building it
60 .DELETE_ON_ERROR:
61
62 HS_DIRS = \
63         src \
64         src/Ganeti \
65         src/Ganeti/Block \
66         src/Ganeti/Block/Drbd \
67         src/Ganeti/Confd \
68         src/Ganeti/Curl \
69         src/Ganeti/DataCollectors \
70         src/Ganeti/HTools \
71         src/Ganeti/HTools/Backend \
72         src/Ganeti/HTools/Program \
73         src/Ganeti/Hypervisor \
74         src/Ganeti/Hypervisor/Xen \
75         src/Ganeti/Monitoring \
76         src/Ganeti/Query \
77         test/hs \
78         test/hs/Test \
79         test/hs/Test/Ganeti \
80         test/hs/Test/Ganeti/Block \
81         test/hs/Test/Ganeti/Block/Drbd \
82         test/hs/Test/Ganeti/Confd \
83         test/hs/Test/Ganeti/HTools \
84         test/hs/Test/Ganeti/HTools/Backend \
85         test/hs/Test/Ganeti/Hypervisor \
86         test/hs/Test/Ganeti/Hypervisor/Xen \
87         test/hs/Test/Ganeti/Query
88
89 # Haskell directories without the roots (src, test/hs)
90 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
91
92 DIRS = \
93         $(HS_DIRS) \
94         autotools \
95         daemons \
96         devel \
97         devel/data \
98         doc \
99         doc/css \
100         doc/examples \
101         doc/examples/gnt-debug \
102         doc/examples/hooks \
103         test/data/htools \
104         test/data/htools/rapi \
105         test/hs/shelltests \
106         lib \
107         lib/build \
108         lib/client \
109         lib/cmdlib \
110         lib/confd \
111         lib/http \
112         lib/hypervisor \
113         lib/impexpd \
114         lib/masterd \
115         lib/rapi \
116         lib/server \
117         lib/tools \
118         lib/utils \
119         lib/watcher \
120         man \
121         qa \
122         test \
123         test/data \
124         test/data/bdev-rbd \
125         test/data/ovfdata \
126         test/data/ovfdata/other \
127         test/py \
128         tools
129
130 ALL_APIDOC_HS_DIRS = \
131         $(APIDOC_HS_DIR) \
132         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
133
134 BUILDTIME_DIR_AUTOCREATE = \
135         scripts \
136         $(APIDOC_DIR) \
137         $(ALL_APIDOC_HS_DIRS) \
138         $(APIDOC_PY_DIR) \
139         $(COVERAGE_DIR) \
140         $(COVERAGE_HS_DIR) \
141         $(COVERAGE_PY_DIR) \
142         .hpc
143
144 BUILDTIME_DIRS = \
145         $(BUILDTIME_DIR_AUTOCREATE) \
146         doc/html \
147         doc/man-html
148
149 DIRCHECK_EXCLUDE = \
150         $(BUILDTIME_DIRS) \
151         ganeti-[0-9]*.[0-9]*.[0-9]* \
152         doc/html/_* \
153         doc/man-html/_* \
154         autom4te.cache
155
156 # some helper vars
157 COVERAGE_DIR = doc/coverage
158 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
159 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
160 APIDOC_DIR = doc/api
161 APIDOC_PY_DIR = $(APIDOC_DIR)/py
162 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
163
164 MAINTAINERCLEANFILES = \
165         $(maninput) \
166         doc/install-quick.rst \
167         doc/news.rst \
168         doc/upgrade.rst \
169         vcs-version
170
171 maintainer-clean-local:
172         rm -rf $(BUILDTIME_DIRS)
173
174 CLEANFILES = \
175         $(addsuffix /*.py[co],$(DIRS)) \
176         $(addsuffix /*.hi,$(HS_DIRS)) \
177         $(addsuffix /*.o,$(HS_DIRS)) \
178         $(PYTHON_BOOTSTRAP) \
179         epydoc.conf \
180         $(REPLACE_VARS_SED) \
181         $(SHELL_ENV_INIT) \
182         daemons/daemon-util \
183         daemons/ganeti-cleaner \
184         devel/squeeze-amd64.tar.gz \
185         devel/squeeze-amd64.conf \
186         $(mandocrst) \
187         doc/manpages-enabled.rst \
188         $(BUILT_EXAMPLES) \
189         doc/examples/bash_completion \
190         doc/examples/bash_completion-debug \
191         lib/_generated_rpc.py \
192         $(man_MANS) \
193         $(manhtml) \
194         tools/kvm-ifup \
195         tools/users-setup \
196         tools/vcluster-setup \
197         stamp-directories \
198         stamp-srclinks \
199         $(nodist_pkgpython_PYTHON) \
200         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
201         $(HS_BUILT_TEST_HELPERS) \
202         src/ganeti-confd \
203         src/ganeti-mond \
204         .hpc/*.mix src/*.tix test/hs/*.tix \
205         doc/hs-lint.html
206
207 GENERATED_FILES = \
208         $(built_base_sources) \
209         $(BUILT_PYTHON_SOURCES) \
210         $(PYTHON_BOOTSTRAP)
211
212 HS_GENERATED_FILES =
213 if WANT_HTOOLS
214 HS_GENERATED_FILES += $(HS_PROGS)
215 if ENABLE_CONFD
216 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
217 endif
218
219 if ENABLE_MOND
220 HS_GENERATED_FILES += src/ganeti-mond
221 endif
222 endif
223
224 built_base_sources = \
225         stamp-directories \
226         stamp-srclinks
227
228 built_python_base_sources = \
229         lib/_autoconf.py \
230         lib/_vcsversion.py
231
232 BUILT_PYTHON_SOURCES = \
233         $(built_python_base_sources) \
234         lib/_generated_rpc.py
235
236 # Generating the RPC wrappers depends on many things, so make sure
237 # it's built at the end of the built sources
238 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
239
240 # these are all built from the underlying %.in sources
241 BUILT_EXAMPLES = \
242         doc/examples/ganeti-kvm-poweroff.initd \
243         doc/examples/ganeti.cron \
244         doc/examples/ganeti.initd \
245         doc/examples/ganeti-master-role.ocf \
246         doc/examples/ganeti-node-role.ocf \
247         doc/examples/gnt-config-backup \
248         doc/examples/hooks/ipsec
249
250 nodist_pkgpython_PYTHON = \
251         $(BUILT_PYTHON_SOURCES)
252
253 noinst_PYTHON = \
254         lib/build/__init__.py \
255         lib/build/shell_example_lexer.py \
256         lib/build/sphinx_ext.py
257
258 pkgpython_PYTHON = \
259         lib/__init__.py \
260         lib/asyncnotifier.py \
261         lib/backend.py \
262         lib/bdev.py \
263         lib/bootstrap.py \
264         lib/cli.py \
265         lib/compat.py \
266         lib/config.py \
267         lib/constants.py \
268         lib/daemon.py \
269         lib/errors.py \
270         lib/hooksmaster.py \
271         lib/ht.py \
272         lib/jqueue.py \
273         lib/jstore.py \
274         lib/locking.py \
275         lib/luxi.py \
276         lib/mcpu.py \
277         lib/netutils.py \
278         lib/objects.py \
279         lib/opcodes.py \
280         lib/outils.py \
281         lib/ovf.py \
282         lib/pathutils.py \
283         lib/qlang.py \
284         lib/query.py \
285         lib/rpc.py \
286         lib/rpc_defs.py \
287         lib/runtime.py \
288         lib/serializer.py \
289         lib/ssconf.py \
290         lib/ssh.py \
291         lib/storage.py \
292         lib/uidpool.py \
293         lib/vcluster.py \
294         lib/network.py \
295         lib/workerpool.py
296
297 client_PYTHON = \
298         lib/client/__init__.py \
299         lib/client/gnt_backup.py \
300         lib/client/gnt_cluster.py \
301         lib/client/gnt_debug.py \
302         lib/client/gnt_group.py \
303         lib/client/gnt_instance.py \
304         lib/client/gnt_job.py \
305         lib/client/gnt_node.py \
306         lib/client/gnt_network.py \
307         lib/client/gnt_os.py \
308         lib/client/gnt_storage.py
309
310 cmdlib_PYTHON = \
311         lib/cmdlib/__init__.py \
312         lib/cmdlib/common.py \
313         lib/cmdlib/base.py \
314         lib/cmdlib/cluster.py \
315         lib/cmdlib/group.py \
316         lib/cmdlib/node.py \
317         lib/cmdlib/instance.py \
318         lib/cmdlib/instance_storage.py \
319         lib/cmdlib/instance_utils.py \
320         lib/cmdlib/backup.py \
321         lib/cmdlib/query.py \
322         lib/cmdlib/operating_system.py \
323         lib/cmdlib/tags.py \
324         lib/cmdlib/network.py \
325         lib/cmdlib/misc.py \
326         lib/cmdlib/test.py
327
328 hypervisor_PYTHON = \
329         lib/hypervisor/__init__.py \
330         lib/hypervisor/hv_base.py \
331         lib/hypervisor/hv_chroot.py \
332         lib/hypervisor/hv_fake.py \
333         lib/hypervisor/hv_kvm.py \
334         lib/hypervisor/hv_lxc.py \
335         lib/hypervisor/hv_xen.py
336
337 rapi_PYTHON = \
338         lib/rapi/__init__.py \
339         lib/rapi/baserlib.py \
340         lib/rapi/client.py \
341         lib/rapi/client_utils.py \
342         lib/rapi/connector.py \
343         lib/rapi/rlib2.py \
344         lib/rapi/testutils.py
345
346 http_PYTHON = \
347         lib/http/__init__.py \
348         lib/http/auth.py \
349         lib/http/client.py \
350         lib/http/server.py
351
352 confd_PYTHON = \
353         lib/confd/__init__.py \
354         lib/confd/client.py
355
356 masterd_PYTHON = \
357         lib/masterd/__init__.py \
358         lib/masterd/iallocator.py \
359         lib/masterd/instance.py
360
361 impexpd_PYTHON = \
362         lib/impexpd/__init__.py
363
364 watcher_PYTHON = \
365         lib/watcher/__init__.py \
366         lib/watcher/nodemaint.py \
367         lib/watcher/state.py
368
369 server_PYTHON = \
370         lib/server/__init__.py \
371         lib/server/masterd.py \
372         lib/server/noded.py \
373         lib/server/rapi.py
374
375 pytools_PYTHON = \
376         lib/tools/__init__.py \
377         lib/tools/burnin.py \
378         lib/tools/ensure_dirs.py \
379         lib/tools/node_cleanup.py \
380         lib/tools/node_daemon_setup.py \
381         lib/tools/prepare_node_join.py
382
383 utils_PYTHON = \
384         lib/utils/__init__.py \
385         lib/utils/algo.py \
386         lib/utils/filelock.py \
387         lib/utils/hash.py \
388         lib/utils/io.py \
389         lib/utils/log.py \
390         lib/utils/lvm.py \
391         lib/utils/mlock.py \
392         lib/utils/nodesetup.py \
393         lib/utils/process.py \
394         lib/utils/retry.py \
395         lib/utils/text.py \
396         lib/utils/wrapper.py \
397         lib/utils/x509.py
398
399 docinput = \
400         doc/conf.py \
401         doc/css/style.css \
402         doc/admin.rst \
403         doc/cluster-merge.rst \
404         doc/design-2.0.rst \
405         doc/design-2.1.rst \
406         doc/design-2.2.rst \
407         doc/design-2.3.rst \
408         doc/design-2.4.rst \
409         doc/design-2.5.rst \
410         doc/design-2.6.rst \
411         doc/design-2.7.rst \
412         doc/design-autorepair.rst \
413         doc/design-bulk-create.rst \
414         doc/design-chained-jobs.rst \
415         doc/design-cpu-pinning.rst \
416         doc/design-device-uuid-name.rst \
417         doc/design-draft.rst \
418         doc/design-htools-2.3.rst \
419         doc/design-http-server.rst \
420         doc/design-impexp2.rst \
421         doc/design-lu-generated-jobs.rst \
422         doc/design-linuxha.rst \
423         doc/design-multi-reloc.rst \
424         doc/design-network.rst \
425         doc/design-node-add.rst \
426         doc/design-oob.rst \
427         doc/design-ovf-support.rst \
428         doc/design-opportunistic-locking.rst \
429         doc/design-partitioned.rst \
430         doc/design-query-splitting.rst \
431         doc/design-query2.rst \
432         doc/design-reason-trail.rst \
433         doc/design-resource-model.rst \
434         doc/design-restricted-commands.rst \
435         doc/design-shared-storage.rst \
436         doc/design-monitoring-agent.rst \
437         doc/design-virtual-clusters.rst \
438         doc/design-x509-ca.rst \
439         doc/design-hroller.rst \
440         doc/design-storagetypes.rst \
441         doc/devnotes.rst \
442         doc/glossary.rst \
443         doc/hooks.rst \
444         doc/iallocator.rst \
445         doc/index.rst \
446         doc/install-quick.rst \
447         doc/install.rst \
448         doc/locking.rst \
449         doc/manpages-disabled.rst \
450         doc/move-instance.rst \
451         doc/news.rst \
452         doc/ovfconverter.rst \
453         doc/rapi.rst \
454         doc/security.rst \
455         doc/upgrade.rst \
456         doc/virtual-cluster.rst \
457         doc/walkthrough.rst
458
459 # Generates file names such as "doc/man-gnt-instance.rst"
460 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
461
462 # Haskell programs to be installed in $PREFIX/bin
463 HS_BIN_PROGS=src/htools
464
465 # Haskell programs to be installed in the MYEXECLIB dir
466 if ENABLE_MOND
467 HS_MYEXECLIB_PROGS=src/mon-collector
468 else
469 HS_MYEXECLIB_PROGS=
470 endif
471
472 # Haskell programs to be compiled by "make really-all"
473 HS_COMPILE_PROGS= \
474         src/ganeti-mond \
475         src/hconfd \
476         src/rpc-test
477
478 # All Haskell non-test programs to be compiled but not automatically installed
479 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
480
481 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
482 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
483
484 HS_ALL_PROGS = \
485         $(HS_PROGS) \
486         test/hs/hpc-htools \
487         test/hs/hpc-mon-collector \
488         test/hs/htest \
489         $(HS_COMPILE_PROGS)
490
491 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
492 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
493
494 HFLAGS = \
495         -O -Wall -Werror -isrc \
496         -fwarn-monomorphism-restriction \
497         -fwarn-tabs \
498         $(GHC_BYVERSION_FLAGS)
499
500 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
501 HEXTRA =
502 # internal extra flags (used for test/hs/htest mainly)
503 HEXTRA_INT =
504 # exclude options for coverage reports
505 HPCEXCL = --exclude Main \
506         --exclude Ganeti.Constants \
507         --exclude Ganeti.HTools.QC \
508         --exclude Ganeti.THH \
509         --exclude Ganeti.Version \
510         --exclude Test.Ganeti.Attoparsec \
511         --exclude Test.Ganeti.TestCommon \
512         --exclude Test.Ganeti.TestHTools \
513         --exclude Test.Ganeti.TestHelper \
514         --exclude Test.Ganeti.TestImports \
515         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
516
517 HS_LIB_SRCS = \
518         src/Ganeti/Block/Drbd/Types.hs \
519         src/Ganeti/Block/Drbd/Parser.hs \
520         src/Ganeti/BasicTypes.hs \
521         src/Ganeti/Common.hs \
522         src/Ganeti/Compat.hs \
523         src/Ganeti/Confd/Client.hs \
524         src/Ganeti/Confd/Server.hs \
525         src/Ganeti/Confd/Types.hs \
526         src/Ganeti/Confd/Utils.hs \
527         src/Ganeti/Config.hs \
528         src/Ganeti/Curl/Multi.hs \
529         src/Ganeti/Daemon.hs \
530         src/Ganeti/DataCollectors/CLI.hs \
531         src/Ganeti/DataCollectors/Drbd.hs \
532         src/Ganeti/DataCollectors/Program.hs \
533         src/Ganeti/DataCollectors/Types.hs \
534         src/Ganeti/Errors.hs \
535         src/Ganeti/HTools/Backend/IAlloc.hs \
536         src/Ganeti/HTools/Backend/Luxi.hs \
537         src/Ganeti/HTools/Backend/Rapi.hs \
538         src/Ganeti/HTools/Backend/Simu.hs \
539         src/Ganeti/HTools/Backend/Text.hs \
540         src/Ganeti/HTools/CLI.hs \
541         src/Ganeti/HTools/Cluster.hs \
542         src/Ganeti/HTools/Container.hs \
543         src/Ganeti/HTools/ExtLoader.hs \
544         src/Ganeti/HTools/Graph.hs \
545         src/Ganeti/HTools/Group.hs \
546         src/Ganeti/HTools/Instance.hs \
547         src/Ganeti/HTools/Loader.hs \
548         src/Ganeti/HTools/Node.hs \
549         src/Ganeti/HTools/PeerMap.hs \
550         src/Ganeti/HTools/Program/Hail.hs \
551         src/Ganeti/HTools/Program/Harep.hs \
552         src/Ganeti/HTools/Program/Hbal.hs \
553         src/Ganeti/HTools/Program/Hcheck.hs \
554         src/Ganeti/HTools/Program/Hinfo.hs \
555         src/Ganeti/HTools/Program/Hscan.hs \
556         src/Ganeti/HTools/Program/Hspace.hs \
557         src/Ganeti/HTools/Program/Hroller.hs \
558         src/Ganeti/HTools/Program/Main.hs \
559         src/Ganeti/HTools/Types.hs \
560         src/Ganeti/Hypervisor/Xen/XmParser.hs \
561         src/Ganeti/Hypervisor/Xen/Types.hs \
562         src/Ganeti/Hash.hs \
563         src/Ganeti/JQueue.hs \
564         src/Ganeti/JSON.hs \
565         src/Ganeti/Jobs.hs \
566         src/Ganeti/Logging.hs \
567         src/Ganeti/Luxi.hs \
568         src/Ganeti/Monitoring/Server.hs \
569         src/Ganeti/Network.hs \
570         src/Ganeti/Objects.hs \
571         src/Ganeti/OpCodes.hs \
572         src/Ganeti/OpParams.hs \
573         src/Ganeti/Path.hs \
574         src/Ganeti/Query/Common.hs \
575         src/Ganeti/Query/Export.hs \
576         src/Ganeti/Query/Filter.hs \
577         src/Ganeti/Query/Group.hs \
578         src/Ganeti/Query/Job.hs \
579         src/Ganeti/Query/Language.hs \
580         src/Ganeti/Query/Network.hs \
581         src/Ganeti/Query/Node.hs \
582         src/Ganeti/Query/Query.hs \
583         src/Ganeti/Query/Server.hs \
584         src/Ganeti/Query/Types.hs \
585         src/Ganeti/Rpc.hs \
586         src/Ganeti/Runtime.hs \
587         src/Ganeti/Ssconf.hs \
588         src/Ganeti/THH.hs \
589         src/Ganeti/Types.hs \
590         src/Ganeti/Utils.hs
591
592 HS_TEST_SRCS = \
593         test/hs/Test/Ganeti/Attoparsec.hs \
594         test/hs/Test/Ganeti/BasicTypes.hs \
595         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
596         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
597         test/hs/Test/Ganeti/Common.hs \
598         test/hs/Test/Ganeti/Confd/Types.hs \
599         test/hs/Test/Ganeti/Confd/Utils.hs \
600         test/hs/Test/Ganeti/Daemon.hs \
601         test/hs/Test/Ganeti/Errors.hs \
602         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
603         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
604         test/hs/Test/Ganeti/HTools/CLI.hs \
605         test/hs/Test/Ganeti/HTools/Cluster.hs \
606         test/hs/Test/Ganeti/HTools/Container.hs \
607         test/hs/Test/Ganeti/HTools/Graph.hs \
608         test/hs/Test/Ganeti/HTools/Instance.hs \
609         test/hs/Test/Ganeti/HTools/Loader.hs \
610         test/hs/Test/Ganeti/HTools/Node.hs \
611         test/hs/Test/Ganeti/HTools/PeerMap.hs \
612         test/hs/Test/Ganeti/HTools/Types.hs \
613         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
614         test/hs/Test/Ganeti/JSON.hs \
615         test/hs/Test/Ganeti/Jobs.hs \
616         test/hs/Test/Ganeti/JQueue.hs \
617         test/hs/Test/Ganeti/Luxi.hs \
618         test/hs/Test/Ganeti/Network.hs \
619         test/hs/Test/Ganeti/Objects.hs \
620         test/hs/Test/Ganeti/OpCodes.hs \
621         test/hs/Test/Ganeti/Query/Filter.hs \
622         test/hs/Test/Ganeti/Query/Language.hs \
623         test/hs/Test/Ganeti/Query/Network.hs \
624         test/hs/Test/Ganeti/Query/Query.hs \
625         test/hs/Test/Ganeti/Rpc.hs \
626         test/hs/Test/Ganeti/Runtime.hs \
627         test/hs/Test/Ganeti/Ssconf.hs \
628         test/hs/Test/Ganeti/THH.hs \
629         test/hs/Test/Ganeti/TestCommon.hs \
630         test/hs/Test/Ganeti/TestHTools.hs \
631         test/hs/Test/Ganeti/TestHelper.hs \
632         test/hs/Test/Ganeti/Types.hs \
633         test/hs/Test/Ganeti/Utils.hs
634
635 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
636
637 HS_BUILT_SRCS = \
638         test/hs/Test/Ganeti/TestImports.hs \
639         src/Ganeti/Constants.hs \
640         src/Ganeti/Curl/Internal.hs \
641         src/Ganeti/Version.hs
642 HS_BUILT_SRCS_IN = \
643         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
644         src/Ganeti/Curl/Internal.hsc
645
646 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
647
648 $(RUN_IN_TEMPDIR): | stamp-directories
649
650 doc/html/index.html: ENABLE_MANPAGES =
651 doc/man-html/index.html: ENABLE_MANPAGES = 1
652 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
653
654 # Note: we use here an order-only prerequisite, as the contents of
655 # _autoconf.py are not actually influencing the html build output: it
656 # has to exist in order for the sphinx module to be loaded
657 # successfully, but we certainly don't want the docs to be rebuilt if
658 # it changes
659 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
660         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
661         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
662         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
663         | $(BUILT_PYTHON_SOURCES)
664         @test -n "$(SPHINX)" || \
665             { echo 'sphinx-build' not found during configure; exit 1; }
666 if !MANPAGES_IN_DOC
667         if test -n '$(ENABLE_MANPAGES)'; then \
668           echo 'Man pages in documentation were disabled at configure time' >&2; \
669           exit 1; \
670         fi
671 endif
672 ## Sphinx provides little control over what content should be included. Some
673 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
674 ## build two different versions of the documentation--once without man pages and
675 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
676 ## us with this, but requires running in a temporary directory. It moves the
677 ## correct files into place depending on environment variables.
678         dir=$(dir $@) && \
679         @mkdir_p@ $$dir && \
680         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
681         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
682             -d . \
683             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
684             -D release="$(PACKAGE_VERSION)" \
685             -D graphviz_dot="$(DOT)" \
686             -D enable_manpages="$(ENABLE_MANPAGES)" \
687             doc $(CURDIR)/$$dir && \
688         rm -f $$dir/.buildinfo $$dir/objects.inv
689         touch $@
690
691 doc/html: doc/html/index.html
692
693 doc/man-html: doc/man-html/index.html
694
695 doc/install-quick.rst: INSTALL
696 doc/news.rst: NEWS
697 doc/upgrade.rst: UPGRADE
698
699 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
700         set -e; \
701         { echo '.. This file is automatically updated at build time from $<.'; \
702           echo '.. Do not edit.'; \
703           echo; \
704           cat $<; \
705         } > $@
706
707 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
708         { echo '.. This file is automatically generated, do not edit!'; \
709           echo ''; \
710           echo 'Man pages'; \
711           echo '========='; \
712           echo; \
713           echo '.. toctree::'; \
714           echo '   :maxdepth: 1'; \
715           echo; \
716           for i in $(notdir $(mandocrst)); do \
717             echo "   $$i"; \
718           done | LC_ALL=C sort; \
719         } > $@
720
721 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
722 if MANPAGES_IN_DOC
723         { echo '.. This file is automatically updated at build time from $<.'; \
724           echo '.. Do not edit.'; \
725           echo; \
726           echo "$*"; \
727           echo '=========================================='; \
728           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
729         } > $@
730 else
731         echo 'Man pages in documentation were disabled at configure time' >&2; \
732         exit 1;
733 endif
734
735 # Things to build but not to install (add it to EXTRA_DIST if it should be
736 # distributed)
737 noinst_DATA = \
738         doc/html \
739         $(BUILT_EXAMPLES) \
740         doc/examples/bash_completion \
741         doc/examples/bash_completion-debug \
742         $(manhtml)
743
744 if MANPAGES_IN_DOC
745 noinst_DATA += doc/man-html
746 endif
747
748 gnt_scripts = \
749         scripts/gnt-backup \
750         scripts/gnt-cluster \
751         scripts/gnt-debug \
752         scripts/gnt-group \
753         scripts/gnt-instance \
754         scripts/gnt-job \
755         scripts/gnt-network \
756         scripts/gnt-node \
757         scripts/gnt-os \
758         scripts/gnt-storage
759
760 PYTHON_BOOTSTRAP_SBIN = \
761         daemons/ganeti-masterd \
762         daemons/ganeti-noded \
763         daemons/ganeti-rapi \
764         daemons/ganeti-watcher \
765         $(gnt_scripts)
766
767 PYTHON_BOOTSTRAP = \
768         $(PYTHON_BOOTSTRAP_SBIN) \
769         tools/burnin \
770         tools/ensure-dirs \
771         tools/node-cleanup \
772         tools/node-daemon-setup \
773         tools/prepare-node-join
774
775 qa_scripts = \
776         qa/__init__.py \
777         qa/ganeti-qa.py \
778         qa/qa_cluster.py \
779         qa/qa_config.py \
780         qa/qa_daemon.py \
781         qa/qa_env.py \
782         qa/qa_error.py \
783         qa/qa_group.py \
784         qa/qa_instance.py \
785         qa/qa_job.py \
786         qa/qa_node.py \
787         qa/qa_os.py \
788         qa/qa_rapi.py \
789         qa/qa_tags.py \
790         qa/qa_utils.py
791
792 bin_SCRIPTS =
793 if WANT_HTOOLS
794 bin_SCRIPTS += $(HS_BIN_PROGS)
795 install-exec-hook:
796         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
797 # FIXME: this is a hardcoded logic, instead of auto-resolving
798         $(LN_S) -f ../../../bin/htools \
799           $(DESTDIR)$(iallocatorsdir)/hail
800         for role in $(HS_BIN_ROLES); do \
801           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
802         done
803 endif
804
805 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
806         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
807           echo "Error: cannot run unittests without the development" \
808                " libraries (see devnotes.rst)" 1>&2; \
809           exit 1; \
810         fi
811         @rm -f $(notdir $@).tix
812         $(GHC) --make \
813           $(HFLAGS) \
814           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
815           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
816           $(HEXTRA) $(HEXTRA_INT) $@
817         @touch "$@"
818
819 # for the test/hs/htest binary, we need to enable profiling/coverage
820 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
821
822 # we compile the hpc-htools binary with the program coverage
823 test/hs/hpc-htools: HEXTRA_INT=-fhpc
824
825 # we compile the hpc-mon-collector binary with the program coverage
826 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
827
828 # test dependency
829 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
830
831 # rules for building profiling-enabled versions of the haskell
832 # programs: hs-prof does the full two-step build, whereas
833 # hs-prof-quick does only the final rebuild (hs-prof must have been
834 # run before)
835 .PHONY: hs-prof hs-prof-quick
836 hs-prof:
837         @if [ -z "$(TARGET)" ]; then \
838           echo "You need to define TARGET when running this rule" 1>&2; \
839           exit 1; \
840         fi
841         $(MAKE) $(AM_MAKEFLAGS) clean
842         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
843         rm -f $(HS_ALL_PROGS)
844         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
845
846 hs-prof-quick:
847         @if [ -z "$(TARGET)" ]; then \
848           echo "You need to define TARGET when running this rule" 1>&2; \
849           exit 1; \
850         fi
851         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
852
853 dist_sbin_SCRIPTS = \
854         tools/ganeti-listrunner
855
856 nodist_sbin_SCRIPTS = \
857         $(PYTHON_BOOTSTRAP_SBIN) \
858         daemons/ganeti-cleaner
859
860 if ENABLE_CONFD
861 src/ganeti-confd: src/hconfd
862         cp -f $< $@
863
864 nodist_sbin_SCRIPTS += src/ganeti-confd
865 endif
866
867 if ENABLE_MOND
868 nodist_sbin_SCRIPTS += src/ganeti-mond
869 endif
870
871 python_scripts = \
872         tools/cfgshell \
873         tools/cfgupgrade \
874         tools/cfgupgrade12 \
875         tools/cluster-merge \
876         tools/confd-client \
877         tools/fmtjson \
878         tools/lvmstrap \
879         tools/move-instance \
880         tools/ovfconverter \
881         tools/sanitize-config
882
883 dist_tools_SCRIPTS = \
884         $(python_scripts) \
885         tools/burnin \
886         tools/kvm-console-wrapper \
887         tools/master-ip-setup \
888         tools/xen-console-wrapper
889
890 nodist_tools_python_scripts = \
891         tools/node-cleanup
892
893 nodist_tools_SCRIPTS = \
894         $(nodist_tools_python_scripts) \
895         tools/users-setup \
896         tools/vcluster-setup
897
898 pkglib_python_scripts = \
899         daemons/import-export \
900         tools/check-cert-expired
901
902 nodist_pkglib_python_scripts = \
903         tools/ensure-dirs \
904         tools/node-daemon-setup \
905         tools/prepare-node-join
906
907 myexeclib_SCRIPTS = \
908         daemons/daemon-util \
909         tools/kvm-ifup \
910         $(pkglib_python_scripts) \
911         $(HS_MYEXECLIB_PROGS)
912
913 nodist_myexeclib_SCRIPTS = \
914         $(nodist_pkglib_python_scripts)
915
916 EXTRA_DIST = \
917         NEWS \
918         UPGRADE \
919         epydoc.conf.in \
920         pylintrc \
921         autotools/build-bash-completion \
922         autotools/build-rpc \
923         autotools/check-header \
924         autotools/check-imports \
925         autotools/check-man-dashes \
926         autotools/check-man-references \
927         autotools/check-man-warnings \
928         autotools/check-news \
929         autotools/check-python-code \
930         autotools/check-tar \
931         autotools/check-version \
932         autotools/convert-constants \
933         autotools/docpp \
934         autotools/gen-py-coverage \
935         autotools/sphinx-wrapper \
936         autotools/testrunner \
937         autotools/wrong-hardcoded-paths \
938         $(RUN_IN_TEMPDIR) \
939         daemons/daemon-util.in \
940         daemons/ganeti-cleaner.in \
941         $(pkglib_python_scripts) \
942         devel/upload \
943         devel/webserver \
944         tools/kvm-ifup.in \
945         tools/users-setup.in \
946         tools/vcluster-setup.in \
947         $(docinput) \
948         doc/html \
949         $(BUILT_EXAMPLES:%=%.in) \
950         doc/examples/ganeti.default \
951         doc/examples/ganeti.default-debug \
952         doc/examples/hooks/ethers \
953         doc/examples/gnt-debug/README \
954         doc/examples/gnt-debug/delay0.json \
955         doc/examples/gnt-debug/delay50.json \
956         test/py/lockperf.py \
957         test/py/testutils.py \
958         test/py/mocks.py \
959         $(dist_TESTS) \
960         $(TEST_FILES) \
961         man/footer.rst \
962         $(manrst) \
963         $(maninput) \
964         qa/qa-sample.json \
965         $(qa_scripts) \
966         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
967         $(HS_PROG_SRCS) \
968         src/lint-hints.hs \
969         test/hs/cli-tests-defs.sh \
970         test/hs/offline-test.sh \
971         .ghci
972
973 man_MANS = \
974         man/ganeti-cleaner.8 \
975         man/ganeti-confd.8 \
976         man/ganeti-listrunner.8 \
977         man/ganeti-masterd.8 \
978         man/ganeti-mond.8 \
979         man/ganeti-noded.8 \
980         man/ganeti-os-interface.7 \
981         man/ganeti-extstorage-interface.7 \
982         man/ganeti-rapi.8 \
983         man/ganeti-watcher.8 \
984         man/ganeti.7 \
985         man/gnt-backup.8 \
986         man/gnt-cluster.8 \
987         man/gnt-debug.8 \
988         man/gnt-group.8 \
989         man/gnt-network.8 \
990         man/gnt-instance.8 \
991         man/gnt-job.8 \
992         man/gnt-node.8 \
993         man/gnt-os.8 \
994         man/gnt-storage.8 \
995         man/hail.1 \
996         man/hbal.1 \
997         man/hcheck.1 \
998         man/hinfo.1 \
999         man/hscan.1 \
1000         man/hspace.1 \
1001         man/hroller.1 \
1002         man/htools.1 \
1003         man/mon-collector.7
1004
1005 # Remove extensions from all filenames in man_MANS
1006 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1007
1008 manrst = $(patsubst %,%.rst,$(mannoext))
1009 manhtml = $(patsubst %.rst,%.html,$(manrst))
1010 mangen = $(patsubst %.rst,%.gen,$(manrst))
1011 maninput = \
1012         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1013         $(patsubst %.html,%.html.in,$(manhtml)) \
1014         $(mangen)
1015
1016 TEST_FILES = \
1017         test/data/htools/clean-nonzero-score.data \
1018         test/data/htools/common-suffix.data \
1019         test/data/htools/empty-cluster.data \
1020         test/data/htools/hail-alloc-drbd.json \
1021         test/data/htools/hail-alloc-invalid-twodisks.json \
1022         test/data/htools/hail-alloc-twodisks.json \
1023         test/data/htools/hail-change-group.json \
1024         test/data/htools/hail-invalid-reloc.json \
1025         test/data/htools/hail-node-evac.json \
1026         test/data/htools/hail-reloc-drbd.json \
1027         test/data/htools/hbal-excl-tags.data \
1028         test/data/htools/hbal-split-insts.data \
1029         test/data/htools/hspace-tiered-dualspec.data \
1030         test/data/htools/hspace-tiered.data \
1031         test/data/htools/invalid-node.data \
1032         test/data/htools/missing-resources.data \
1033         test/data/htools/multiple-master.data \
1034         test/data/htools/n1-failure.data \
1035         test/data/htools/rapi/groups.json \
1036         test/data/htools/rapi/info.json \
1037         test/data/htools/rapi/instances.json \
1038         test/data/htools/rapi/nodes.json \
1039         test/data/htools/unique-reboot-order.data \
1040         test/hs/shelltests/htools-balancing.test \
1041         test/hs/shelltests/htools-basic.test \
1042         test/hs/shelltests/htools-dynutil.test \
1043         test/hs/shelltests/htools-excl.test \
1044         test/hs/shelltests/htools-hail.test \
1045         test/hs/shelltests/htools-hroller.test \
1046         test/hs/shelltests/htools-hspace.test \
1047         test/hs/shelltests/htools-invalid.test \
1048         test/hs/shelltests/htools-multi-group.test \
1049         test/hs/shelltests/htools-no-backend.test \
1050         test/hs/shelltests/htools-rapi.test \
1051         test/hs/shelltests/htools-single-group.test \
1052         test/hs/shelltests/htools-text-backend.test \
1053         test/hs/shelltests/htools-mon-collector.test \
1054         test/data/bdev-drbd-8.0.txt \
1055         test/data/bdev-drbd-8.3.txt \
1056         test/data/bdev-drbd-disk.txt \
1057         test/data/bdev-drbd-net-ip4.txt \
1058         test/data/bdev-drbd-net-ip6.txt \
1059         test/data/bdev-rbd/json_output_empty.txt \
1060         test/data/bdev-rbd/json_output_extra_matches.txt \
1061         test/data/bdev-rbd/json_output_no_matches.txt \
1062         test/data/bdev-rbd/json_output_ok.txt \
1063         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1064         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1065         test/data/bdev-rbd/plain_output_new_ok.txt \
1066         test/data/bdev-rbd/plain_output_old_empty.txt \
1067         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1068         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1069         test/data/bdev-rbd/plain_output_old_ok.txt \
1070         test/data/bdev-rbd/output_invalid.txt \
1071         test/data/cert1.pem \
1072         test/data/cert2.pem \
1073         test/data/cluster_config_2.7.json \
1074         test/data/cluster_config_downgraded_2.7.json \
1075         test/data/instance-minor-pairing.txt \
1076         test/data/ip-addr-show-dummy0.txt \
1077         test/data/ip-addr-show-lo-ipv4.txt \
1078         test/data/ip-addr-show-lo-ipv6.txt \
1079         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1080         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1081         test/data/ip-addr-show-lo-oneline.txt \
1082         test/data/ip-addr-show-lo.txt \
1083         test/data/kvm_0.12.5_help.txt \
1084         test/data/kvm_0.15.90_help.txt \
1085         test/data/kvm_0.9.1_help.txt \
1086         test/data/kvm_0.9.1_help_boot_test.txt \
1087         test/data/kvm_1.0_help.txt \
1088         test/data/kvm_1.1.2_help.txt \
1089         test/data/ovfdata/compr_disk.vmdk.gz \
1090         test/data/ovfdata/config.ini \
1091         test/data/ovfdata/corrupted_resources.ovf \
1092         test/data/ovfdata/empty.ini \
1093         test/data/ovfdata/empty.ovf \
1094         test/data/ovfdata/ganeti.mf \
1095         test/data/ovfdata/ganeti.ovf \
1096         test/data/ovfdata/gzip_disk.ovf \
1097         test/data/ovfdata/new_disk.vmdk \
1098         test/data/ovfdata/no_disk.ini \
1099         test/data/ovfdata/no_disk_in_ref.ovf \
1100         test/data/ovfdata/no_os.ini \
1101         test/data/ovfdata/no_ovf.ova \
1102         test/data/ovfdata/other/rawdisk.raw \
1103         test/data/ovfdata/ova.ova \
1104         test/data/ovfdata/rawdisk.raw \
1105         test/data/ovfdata/second_disk.vmdk \
1106         test/data/ovfdata/unsafe_path.ini \
1107         test/data/ovfdata/virtualbox.ovf \
1108         test/data/ovfdata/wrong_config.ini \
1109         test/data/ovfdata/wrong_extension.ovd \
1110         test/data/ovfdata/wrong_manifest.mf \
1111         test/data/ovfdata/wrong_manifest.ovf \
1112         test/data/ovfdata/wrong_ova.ova \
1113         test/data/ovfdata/wrong_xml.ovf \
1114         test/data/proc_drbd8.txt \
1115         test/data/proc_drbd80-emptyline.txt \
1116         test/data/proc_drbd83.txt \
1117         test/data/proc_drbd83_sync.txt \
1118         test/data/proc_drbd83_sync_want.txt \
1119         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1120         test/data/qa-minimal-nodes-instances-only.json \
1121         test/data/sys_drbd_usermode_helper.txt \
1122         test/data/vgreduce-removemissing-2.02.02.txt \
1123         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1124         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1125         test/data/vgs-missing-pvs-2.02.02.txt \
1126         test/data/vgs-missing-pvs-2.02.66.txt \
1127         test/data/xen-xm-info-4.0.1.txt \
1128         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1129         test/data/xen-xm-list-4.0.1-four-instances.txt \
1130         test/data/xen-xm-list-long-4.0.1.txt \
1131         test/data/xen-xm-uptime-4.0.1.txt \
1132         test/py/ganeti-cli.test \
1133         test/py/gnt-cli.test \
1134         test/py/import-export_unittest-helper
1135
1136 python_tests = \
1137         doc/examples/rapi_testutils.py \
1138         test/py/cfgupgrade_unittest.py \
1139         test/py/docs_unittest.py \
1140         test/py/ganeti.asyncnotifier_unittest.py \
1141         test/py/ganeti.backend_unittest-runasroot.py \
1142         test/py/ganeti.backend_unittest.py \
1143         test/py/ganeti.bdev_unittest.py \
1144         test/py/ganeti.cli_unittest.py \
1145         test/py/ganeti.client.gnt_cluster_unittest.py \
1146         test/py/ganeti.client.gnt_instance_unittest.py \
1147         test/py/ganeti.client.gnt_job_unittest.py \
1148         test/py/ganeti.cmdlib_unittest.py \
1149         test/py/ganeti.compat_unittest.py \
1150         test/py/ganeti.confd.client_unittest.py \
1151         test/py/ganeti.config_unittest.py \
1152         test/py/ganeti.constants_unittest.py \
1153         test/py/ganeti.daemon_unittest.py \
1154         test/py/ganeti.errors_unittest.py \
1155         test/py/ganeti.hooks_unittest.py \
1156         test/py/ganeti.ht_unittest.py \
1157         test/py/ganeti.http_unittest.py \
1158         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1159         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1160         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1161         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1162         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1163         test/py/ganeti.hypervisor_unittest.py \
1164         test/py/ganeti.impexpd_unittest.py \
1165         test/py/ganeti.jqueue_unittest.py \
1166         test/py/ganeti.jstore_unittest.py \
1167         test/py/ganeti.locking_unittest.py \
1168         test/py/ganeti.luxi_unittest.py \
1169         test/py/ganeti.masterd.iallocator_unittest.py \
1170         test/py/ganeti.masterd.instance_unittest.py \
1171         test/py/ganeti.mcpu_unittest.py \
1172         test/py/ganeti.netutils_unittest.py \
1173         test/py/ganeti.objects_unittest.py \
1174         test/py/ganeti.opcodes_unittest.py \
1175         test/py/ganeti.outils_unittest.py \
1176         test/py/ganeti.ovf_unittest.py \
1177         test/py/ganeti.qlang_unittest.py \
1178         test/py/ganeti.query_unittest.py \
1179         test/py/ganeti.rapi.baserlib_unittest.py \
1180         test/py/ganeti.rapi.client_unittest.py \
1181         test/py/ganeti.rapi.resources_unittest.py \
1182         test/py/ganeti.rapi.rlib2_unittest.py \
1183         test/py/ganeti.rapi.testutils_unittest.py \
1184         test/py/ganeti.rpc_unittest.py \
1185         test/py/ganeti.runtime_unittest.py \
1186         test/py/ganeti.serializer_unittest.py \
1187         test/py/ganeti.server.rapi_unittest.py \
1188         test/py/ganeti.ssconf_unittest.py \
1189         test/py/ganeti.ssh_unittest.py \
1190         test/py/ganeti.storage_unittest.py \
1191         test/py/ganeti.tools.burnin_unittest.py \
1192         test/py/ganeti.tools.ensure_dirs_unittest.py \
1193         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1194         test/py/ganeti.tools.prepare_node_join_unittest.py \
1195         test/py/ganeti.uidpool_unittest.py \
1196         test/py/ganeti.utils.algo_unittest.py \
1197         test/py/ganeti.utils.filelock_unittest.py \
1198         test/py/ganeti.utils.hash_unittest.py \
1199         test/py/ganeti.utils.io_unittest-runasroot.py \
1200         test/py/ganeti.utils.io_unittest.py \
1201         test/py/ganeti.utils.log_unittest.py \
1202         test/py/ganeti.utils.lvm_unittest.py \
1203         test/py/ganeti.utils.mlock_unittest.py \
1204         test/py/ganeti.utils.nodesetup_unittest.py \
1205         test/py/ganeti.utils.process_unittest.py \
1206         test/py/ganeti.utils.retry_unittest.py \
1207         test/py/ganeti.utils.text_unittest.py \
1208         test/py/ganeti.utils.wrapper_unittest.py \
1209         test/py/ganeti.utils.x509_unittest.py \
1210         test/py/ganeti.utils_unittest.py \
1211         test/py/ganeti.vcluster_unittest.py \
1212         test/py/ganeti.workerpool_unittest.py \
1213         test/py/pycurl_reset_unittest.py \
1214         test/py/qa.qa_config_unittest.py \
1215         test/py/tempfile_fork_unittest.py
1216
1217 haskell_tests = test/hs/htest
1218
1219 dist_TESTS = \
1220         test/py/check-cert-expired_unittest.bash \
1221         test/py/daemon-util_unittest.bash \
1222         test/py/ganeti-cleaner_unittest.bash \
1223         test/py/import-export_unittest.bash \
1224         test/py/cli-test.bash \
1225         test/py/bash_completion.bash \
1226         $(python_tests)
1227
1228 nodist_TESTS =
1229 check_SCRIPTS =
1230
1231 if WANT_HSTESTS
1232 nodist_TESTS += $(haskell_tests)
1233 dist_TESTS += test/hs/offline-test.sh
1234 check_SCRIPTS += \
1235         test/hs/hpc-htools \
1236         test/hs/hpc-mon-collector \
1237         $(HS_BUILT_TEST_HELPERS)
1238 endif
1239
1240 TESTS = $(dist_TESTS) $(nodist_TESTS)
1241
1242 # Environment for all tests
1243 PLAIN_TESTS_ENVIRONMENT = \
1244         PYTHONPATH=. \
1245         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1246         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1247         $(RUN_IN_TEMPDIR)
1248
1249 # Environment for tests run by automake
1250 TESTS_ENVIRONMENT = \
1251         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1252
1253 all_python_code = \
1254         $(dist_sbin_SCRIPTS) \
1255         $(python_scripts) \
1256         $(pkglib_python_scripts) \
1257         $(nodist_pkglib_python_scripts) \
1258         $(nodist_tools_python_scripts) \
1259         $(python_tests) \
1260         $(pkgpython_PYTHON) \
1261         $(client_PYTHON) \
1262         $(cmdlib_PYTHON) \
1263         $(hypervisor_PYTHON) \
1264         $(rapi_PYTHON) \
1265         $(server_PYTHON) \
1266         $(pytools_PYTHON) \
1267         $(http_PYTHON) \
1268         $(confd_PYTHON) \
1269         $(masterd_PYTHON) \
1270         $(impexpd_PYTHON) \
1271         $(utils_PYTHON) \
1272         $(watcher_PYTHON) \
1273         $(noinst_PYTHON) \
1274         $(qa_scripts)
1275
1276 srclink_files = \
1277         man/footer.rst \
1278         test/py/check-cert-expired_unittest.bash \
1279         test/py/daemon-util_unittest.bash \
1280         test/py/ganeti-cleaner_unittest.bash \
1281         test/py/import-export_unittest.bash \
1282         test/py/cli-test.bash \
1283         test/py/bash_completion.bash \
1284         test/hs/offline-test.sh \
1285         test/hs/cli-tests-defs.sh \
1286         $(all_python_code) \
1287         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1288         $(docinput)
1289
1290 check_python_code = \
1291         $(BUILD_BASH_COMPLETION) \
1292         $(CHECK_IMPORTS) \
1293         $(CHECK_HEADER) \
1294         $(DOCPP) \
1295         $(all_python_code)
1296
1297 lint_python_code = \
1298         ganeti \
1299         ganeti/http/server.py \
1300         $(dist_sbin_SCRIPTS) \
1301         $(python_scripts) \
1302         $(pkglib_python_scripts) \
1303         $(BUILD_BASH_COMPLETION) \
1304         $(CHECK_IMPORTS) \
1305         $(CHECK_HEADER) \
1306         $(DOCPP) \
1307         $(PYTHON_BOOTSTRAP)
1308
1309 standalone_python_modules = \
1310         lib/rapi/client.py \
1311         tools/ganeti-listrunner
1312
1313 pep8_python_code = \
1314         ganeti \
1315         ganeti/http/server.py \
1316         $(dist_sbin_SCRIPTS) \
1317         $(python_scripts) \
1318         $(pkglib_python_scripts) \
1319         $(BUILD_BASH_COMPLETION) \
1320         $(CHECK_HEADER) \
1321         $(DOCPP) \
1322         $(PYTHON_BOOTSTRAP) \
1323         qa
1324
1325 test/py/daemon-util_unittest.bash: daemons/daemon-util
1326
1327 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1328
1329 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1330
1331 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1332         sed -f $(REPLACE_VARS_SED) < $< > $@
1333         chmod +x $@
1334
1335 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1336         sed -f $(REPLACE_VARS_SED) < $< > $@
1337         chmod +x $@
1338
1339 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1340         sed -f $(REPLACE_VARS_SED) < $< > $@
1341         chmod +x $@
1342
1343 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1344         sed -f $(REPLACE_VARS_SED) < $< > $@
1345         chmod +x $@
1346
1347 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1348         sed -f $(REPLACE_VARS_SED) < $< > $@
1349
1350 doc/examples/bash_completion: BC_ARGS = --compact
1351 doc/examples/bash_completion-debug: BC_ARGS =
1352
1353 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1354         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1355         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1356         daemons/ganeti-cleaner \
1357         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1358         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1359           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1360
1361 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1362         lib/build/shell_example_lexer.py \
1363         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1364         @echo "Checking $< for hardcoded paths..."
1365         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1366           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1367           exit 1; \
1368         fi
1369         set -e ; \
1370         trap 'echo auto-removing $@; rm $@' EXIT; \
1371         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1372         $(CHECK_MAN_REFERENCES) $@; \
1373         trap - EXIT
1374
1375 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1376         @test -n "$(PANDOC)" || \
1377           { echo 'pandoc' not found during configure; exit 1; }
1378         set -o pipefail -e; \
1379         trap 'echo auto-removing $@; rm $@' EXIT; \
1380         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1381           sed -e 's/\\@/@/g' > $@; \
1382         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1383         $(CHECK_MAN_DASHES) $@; \
1384         trap - EXIT
1385
1386 man/%.html.in: man/%.gen man/footer.rst
1387         @test -n "$(PANDOC)" || \
1388           { echo 'pandoc' not found during configure; exit 1; }
1389         set -o pipefail ; \
1390         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1391           sed -e 's/\\@/@/g' > $@
1392
1393 man/%: man/%.in  $(REPLACE_VARS_SED)
1394         sed -f $(REPLACE_VARS_SED) < $< > $@
1395
1396 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1397         sed -f $(REPLACE_VARS_SED) < $< > $@
1398
1399 vcs-version:
1400         if test -d .git; then \
1401           git describe > $@; \
1402         elif test ! -f $@ ; then \
1403           echo "Cannot auto-generate $@ file"; exit 1; \
1404         fi
1405
1406 .PHONY: clean-vcs-version
1407 clean-vcs-version:
1408         rm -f vcs-version
1409
1410 .PHONY: regen-vcs-version
1411 regen-vcs-version:
1412         @set -e; \
1413         cd $(srcdir); \
1414         if test -d .git; then \
1415           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1416           git describe > $$T; \
1417           if ! cmp --quiet $$T vcs-version; then \
1418             mv $$T vcs-version; \
1419           fi; \
1420         fi
1421
1422 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1423         vcs-version $(built_base_sources)
1424         set -e; \
1425         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1426         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1427
1428 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1429         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1430         lib/jstore.py $(RUN_IN_TEMPDIR) \
1431         $(CONVERT_CONSTANTS) $(built_base_sources) \
1432         | lib/_vcsversion.py
1433         set -e; \
1434         { cat $< ; \
1435           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1436         } > $@
1437
1438 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1439         hsc2hs -o $@ $<
1440
1441 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1442         $(built_base_sources)
1443         set -e; \
1444         { cat $< ; \
1445           echo ; \
1446           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1447             echo "import $$name ()" ; \
1448           done ; \
1449         } > $@
1450
1451 lib/_autoconf.py: Makefile | stamp-directories
1452         set -e; \
1453         { echo '# This file is automatically generated, do not edit!'; \
1454           echo '#'; \
1455           echo ''; \
1456           echo '"""Build-time configuration for Ganeti.'; \
1457           echo '';\
1458           echo 'This file is autogenerated by the build process.'; \
1459           echo 'For any changes you need to re-run ./configure (and'; \
1460           echo 'not edit by hand).'; \
1461           echo ''; \
1462           echo '"""'; \
1463           echo ''; \
1464           echo '# pylint: disable=C0301,C0324'; \
1465           echo '# because this is autogenerated, we do not want'; \
1466           echo '# style warnings' ; \
1467           echo ''; \
1468           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1469           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1470           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1471           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1472           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1473           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1474           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1475           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1476           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1477           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1478           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1479           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1480           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1481           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1482           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1483           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1484           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1485           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1486           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1487           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1488           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1489           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1490           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1491           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1492           echo "KVM_PATH = '$(KVM_PATH)'"; \
1493           echo "IP_PATH = '$(IP_PATH)'"; \
1494           echo "SOCAT_PATH = '$(SOCAT)'"; \
1495           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1496           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1497           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1498           echo "TOOLSDIR = '$(toolsdir)'"; \
1499           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1500           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1501           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1502           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1503           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1504           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1505           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1506           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1507           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1508           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1509           echo "RAPI_USER = '$(RAPI_USER)'"; \
1510           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1511           echo "CONFD_USER = '$(CONFD_USER)'"; \
1512           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1513           echo "NODED_USER = '$(NODED_USER)'"; \
1514           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1515           echo "MOND_USER = '$(MOND_USER)'"; \
1516           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1517           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1518           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1519           echo "HTOOLS = True"; \
1520           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1521           echo "XEN_CMD = '$(XEN_CMD)'"; \
1522           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1523           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1524           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1525 ## Write dictionary with man page name as the key and the section number as the
1526 ## value
1527           echo "MAN_PAGES = {"; \
1528           for i in $(notdir $(man_MANS)); do \
1529             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1530           done; \
1531           echo "}"; \
1532         } > $@
1533
1534 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1535         set -e; \
1536         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1537         { echo '# This file is automatically generated, do not edit!'; \
1538           echo '#'; \
1539           echo ''; \
1540           echo '"""Build-time VCS version number for Ganeti.'; \
1541           echo '';\
1542           echo 'This file is autogenerated by the build process.'; \
1543           echo 'For any changes you need to re-run ./configure (and'; \
1544           echo 'not edit by hand).'; \
1545           echo ''; \
1546           echo '"""'; \
1547           echo ''; \
1548           echo '# pylint: disable=C0301,C0324'; \
1549           echo '# because this is autogenerated, we do not want'; \
1550           echo '# style warnings' ; \
1551           echo ''; \
1552           echo "VCS_VERSION = '$$VCSVER'"; \
1553         } > $@
1554
1555 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1556         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1557
1558 $(SHELL_ENV_INIT): Makefile stamp-directories
1559         set -e; \
1560         { echo '# Allow overriding for tests'; \
1561           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1562           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1563           echo; \
1564           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1565           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1566           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1567           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1568           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1569         } > $@
1570
1571 ## Writes sed script to replace placeholders with build-time values. The
1572 ## additional quotes after the first @ sign are necessary to stop configure
1573 ## from replacing those values as well.
1574 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1575         set -e; \
1576         { echo 's#@''PREFIX@#$(prefix)#g'; \
1577           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1578           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1579           echo 's#@''BINDIR@#$(bindir)#g'; \
1580           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1581           echo 's#@''LIBDIR@#$(libdir)#g'; \
1582           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1583           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1584           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1585           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1586           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1587           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1588           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1589           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1590           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1591           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1592           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1593           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1594           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1595           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1596           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1597           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1598           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1599           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1600           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1601           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1602           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1603           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1604           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1605           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1606           echo; \
1607           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1608           echo '  r $(SHELL_ENV_INIT)'; \
1609           echo '  d'; \
1610           echo '}'; \
1611         } > $@
1612
1613 # Using deferred evaluation
1614 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1615 daemons/ganeti-watcher: MODULE = ganeti.watcher
1616 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1617 tools/burnin: MODULE = ganeti.tools.burnin
1618 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1619 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1620 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1621 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1622 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1623
1624 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1625         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1626         set -e; \
1627         { echo '#!/usr/bin/python'; \
1628           echo '# This file is automatically generated, do not edit!'; \
1629           echo "# Edit $(MODULE) instead."; \
1630           echo; \
1631           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1632           echo; \
1633           echo '# pylint: disable=C0103'; \
1634           echo '# C0103: Invalid name'; \
1635           echo; \
1636           echo 'import sys'; \
1637           echo 'import $(MODULE) as main'; \
1638           echo; \
1639           echo '# Temporarily alias commands until bash completion'; \
1640           echo '# generator is changed'; \
1641           echo 'if hasattr(main, "commands"):'; \
1642           echo '  commands = main.commands # pylint: disable=E1101'; \
1643           echo 'if hasattr(main, "aliases"):'; \
1644           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1645           echo; \
1646           echo 'if __name__ == "__main__":'; \
1647           echo '  sys.exit(main.Main())'; \
1648         } > $@
1649         chmod u+x $@
1650
1651 $(HS_BUILT_TEST_HELPERS): Makefile
1652         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1653         set -e; \
1654         { echo '#!/bin/sh'; \
1655           echo '# This file is automatically generated, do not edit!'; \
1656           echo "# Edit Makefile.am instead."; \
1657           echo; \
1658           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1659         } > $@
1660         chmod u+x $@
1661
1662 stamp-directories: Makefile
1663         $(MAKE) $(AM_MAKEFLAGS) ganeti
1664         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1665         touch $@
1666
1667 # We need to create symlinks because "make distcheck" will not install Python
1668 # files when building.
1669 stamp-srclinks: Makefile | stamp-directories
1670         set -e; \
1671         for i in $(srclink_files); do \
1672           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1673             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1674           fi; \
1675         done
1676         touch $@
1677
1678 .PHONY: ganeti
1679 ganeti:
1680         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1681
1682 .PHONY: check-dirs
1683 check-dirs: $(GENERATED_FILES)
1684         @set -e; \
1685         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1686           error=; \
1687           while read dir; do \
1688             case "$$dir" in \
1689               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1690               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1691             esac; \
1692           done; \
1693           for dir in $(DIRS); do \
1694             if ! test -d "$$dir"; then \
1695               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1696               error=1; \
1697             fi \
1698           done; \
1699           test -z "$$error"; \
1700         }
1701
1702 .PHONY: check-local
1703 check-local: check-dirs $(GENERATED_FILES)
1704         $(CHECK_PYTHON_CODE) $(check_python_code)
1705         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1706         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1707         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1708         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1709         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1710         error= ; \
1711         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1712           echo "Incorrect version in README, expected $$expver" >&2; \
1713           error=1; \
1714         fi; \
1715         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1716             doc/security.rst; do \
1717           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1718             "Documents Ganeti version $$expver"; then \
1719             echo "Incorrect version in $$file, expected $$expver" >&2; \
1720             error=1; \
1721           fi; \
1722         done; \
1723         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1724           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1725           error=1; \
1726         fi; \
1727         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1728           ".. Last updated for Ganeti $$expver"; then \
1729           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1730           error=1; \
1731         fi; \
1732         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1733           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1734             echo "Longest line in $$file is longer than 80 characters" >&2; \
1735             error=1; \
1736           fi; \
1737         done; \
1738         test -z "$$error"
1739
1740 .PHONY: hs-tests
1741 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1742         @rm -f htest.tix
1743         ./test/hs/htest
1744
1745 .PHONY: hs-shell
1746 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1747         @rm -f hpc-htools.tix hpc-mon-collector.tix
1748         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1749
1750 .PHONY: hs-check
1751 hs-check: hs-tests hs-shell
1752
1753 # E111: indentation is not a multiple of four
1754 # E121: continuation line indentation is not a multiple of four
1755 #       (since our indent level is not 4)
1756 # E125: continuation line does not distinguish itself from next logical line
1757 #       (since our indent level is not 4)
1758 # E127: continuation line over-indented for visual indent
1759 #       (since our indent level is not 4)
1760 # note: do NOT add E128 here; it's a valid style error in most cases!
1761 # I've seen real errors, but also some cases were we indent wrongly
1762 # due to line length; try to rework the cases where it is triggered,
1763 # instead of silencing it
1764 # E261: at least two spaces before inline comment
1765 # E501: line too long (80 characters)
1766 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1767
1768 # For excluding pep8 expects filenames only, not whole paths
1769 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1770
1771 LINT_TARGETS = pylint pylint-qa
1772 if HAS_PEP8
1773 LINT_TARGETS += pep8
1774 endif
1775 if HAS_HLINT
1776 LINT_TARGETS += hlint
1777 endif
1778
1779 .PHONY: lint
1780 lint: $(LINT_TARGETS)
1781
1782 .PHONY: pylint
1783 pylint: $(GENERATED_FILES)
1784         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1785         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1786
1787 .PHONY: pylint-qa
1788 pylint-qa: $(GENERATED_FILES)
1789         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1790         cd $(top_srcdir)/qa && \
1791           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1792           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1793
1794 .PHONY: pep8
1795 pep8: $(GENERATED_FILES)
1796         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1797         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1798           --repeat $(pep8_python_code)
1799
1800 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1801 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1802 .PHONY: hlint
1803 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1804         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1805         @rm -f doc/hs-lint.html
1806         if tty -s; then C="-c"; else C=""; fi; \
1807         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1808           --ignore "Use first" \
1809           --ignore "Use &&&" \
1810           --ignore "Use void" \
1811           --ignore "Reduce duplication" \
1812           --hint src/lint-hints \
1813           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1814         @if [ ! -f doc/hs-lint.html ]; then \
1815           echo "All good" > doc/hs-lint.html; \
1816         fi
1817
1818 # a dist hook rule for updating the vcs-version file; this is
1819 # hardcoded due to where it needs to build the file...
1820 dist-hook:
1821         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1822         rm -f $(top_distdir)/vcs-version
1823         cp -p $(srcdir)/vcs-version $(top_distdir)
1824
1825 # a distcheck hook rule for catching revision control directories
1826 distcheck-hook:
1827         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1828           echo "Found revision control files in final archive." 1>&2; \
1829           exit 1; \
1830         fi
1831         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1832           echo "Found Python byte code in final archive." 1>&2; \
1833           exit 1; \
1834         fi
1835         if find $(top_distdir) -name '*~' | grep .; then \
1836           echo "Found backup files in final archive." 1>&2; \
1837           exit 1; \
1838         fi
1839 # Empty files or directories should not be distributed. They can cause
1840 # unnecessary warnings for packagers. Directories used by automake during
1841 # distcheck must be excluded.
1842         if find $(top_distdir) -empty -and -not \( \
1843             -path $(top_distdir)/_build -or \
1844             -path $(top_distdir)/_inst \) | grep .; then \
1845           echo "Found empty files or directories in final archive." 1>&2; \
1846           exit 1; \
1847         fi
1848         if test -e $(top_distdir)/doc/man-html; then \
1849           echo "Found documentation including man pages in final archive" >&2; \
1850           exit 1; \
1851         fi
1852
1853 # Backwards compatible distcheck-release target
1854 distcheck-release: distcheck
1855
1856 distrebuildcheck: dist
1857         set -e; \
1858         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1859         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1860         cd $$builddir; \
1861         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1862         cd $(distdir); \
1863         ./configure; \
1864         $(MAKE) maintainer-clean; \
1865         cp $(abs_srcdir)/vcs-version .; \
1866         ./configure; \
1867         $(MAKE) $(AM_MAKEFLAGS)
1868
1869 dist-release: dist
1870         set -e; \
1871         for i in $(DIST_ARCHIVES); do \
1872           echo -n "Checking $$i ... "; \
1873           autotools/check-tar < $$i; \
1874           echo OK; \
1875         done
1876
1877 install-exec-local:
1878         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1879           "$(DESTDIR)${localstatedir}/log/ganeti" \
1880           "$(DESTDIR)${localstatedir}/run/ganeti"
1881
1882 .PHONY: apidoc
1883 if WANT_HSAPIDOC
1884 apidoc: py-apidoc hs-apidoc
1885 else
1886 apidoc: py-apidoc
1887 endif
1888
1889 .PHONY: py-apidoc
1890 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1891         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1892         $(RUN_IN_TEMPDIR) epydoc -v \
1893           --conf $(CURDIR)/epydoc.conf \
1894           --output $(CURDIR)/$(APIDOC_PY_DIR)
1895
1896 .PHONY: hs-apidoc
1897 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1898
1899 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1900         @test -n "$(HSCOLOUR)" || \
1901             { echo 'HsColour' not found during configure; exit 1; }
1902         @test -n "$(HADDOCK)" || \
1903             { echo 'haddock' not found during configure; exit 1; }
1904         rm -rf $(APIDOC_HS_DIR)/*
1905         for i in $(ALL_APIDOC_HS_DIRS); do \
1906           @mkdir_p@ $$i; \
1907           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1908         done
1909         set -e ; \
1910         export LC_ALL=en_US.UTF-8; \
1911         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1912         if [ "$(HS_PARALLEL3)" ]; \
1913         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1914         fi; \
1915         if [ "$(HS_REGEX_PCRE)" ]; \
1916         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1917         fi; \
1918         for file in $(HS_LIBTESTBUILT_SRCS); do \
1919           f_nosrc=$${file##src/}; \
1920           f_notst=$${f_nosrc##test/hs/}; \
1921           f_html=$${f_notst%%.hs}.html; \
1922           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1923         done ; \
1924         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1925           -t ganeti -p src/haddock-prologue \
1926           --source-module="%{MODULE/.//}.html" \
1927           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1928           $$OPTGHC \
1929           $(HS_LIBTESTBUILT_SRCS)
1930
1931 .PHONY: TAGS
1932 TAGS: $(GENERATED_FILES)
1933         rm -f TAGS
1934         $(GHC) -e ":etags" -v0 \
1935           $(filter-out -O -Werror,$(HFLAGS)) \
1936           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1937           $(HS_LIBTEST_SRCS)
1938         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1939           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1940           -path './qa/*.py' | \
1941           etags -l python -a -
1942
1943 .PHONY: coverage
1944 if WANT_HTOOLS
1945 coverage: py-coverage hs-coverage
1946 else
1947 coverage: py-coverage
1948 endif
1949
1950 .PHONY: py-coverage
1951 py-coverage: $(GENERATED_FILES) $(python_tests)
1952         @test -n "$(PYCOVERAGE)" || \
1953             { echo 'python-coverage' not found during configure; exit 1; }
1954         set -e; \
1955         COVERAGE=$(PYCOVERAGE) \
1956         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1957         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1958         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1959         $(PLAIN_TESTS_ENVIRONMENT) \
1960         $(abs_top_srcdir)/autotools/gen-py-coverage \
1961         $(python_tests)
1962
1963 .PHONY: hs-coverage
1964 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1965         rm -f *.tix
1966         $(MAKE) $(AM_MAKEFLAGS) hs-check
1967         @mkdir_p@ $(COVERAGE_HS_DIR)
1968         hpc sum --union $(HPCEXCL) \
1969           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1970         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1971         hpc report coverage-hs.tix
1972         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1973
1974 # Special "kind-of-QA" target for htools, needs special setup (all
1975 # tools compiled with -fhpc)
1976 .PHONY: live-test
1977 live-test: all
1978         set -e ; \
1979         cd src; \
1980         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1981         rm -f *.tix *.mix; \
1982         ./live-test.sh; \
1983         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1984           --output=live-test.tix ; \
1985         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1986         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1987           --srcdir=.. $(HPCEXCL) ; \
1988         hpc report --srcdir=.. live-test $(HPCEXCL)
1989
1990 commit-check: distcheck lint apidoc
1991
1992 .PHONY: gitignore-check
1993 gitignore-check:
1994         @if [ -n "`git status --short`" ]; then \
1995           echo "Git status is not clean!" 1>&2 ; \
1996           git status --short; \
1997           exit 1; \
1998         fi
1999
2000 # target to rebuild all man pages (both groff and html output)
2001 .PHONY: man
2002 man: $(man_MANS) $(manhtml)
2003
2004 # Target that builds all binaries (including those that are not
2005 # rebuilt except when running the tests)
2006 .PHONY: really-all
2007 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2008
2009 # we don't need the ancient implicit rules:
2010 %: %,v
2011 %: RCS/%,v
2012 %: RCS/%
2013 %: s.%
2014 %: SCCS/s.%
2015
2016 -include ./Makefile.local
2017
2018 # vim: set noet :